package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerAccessoryService;
import com.gxwebsoft.tower.entity.TowerAccessory;
import com.gxwebsoft.tower.param.TowerAccessoryParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 配件管理控制器
 *
 * @author 科技小王子
 * @since 2023-05-22 11:53:48
 */
@Api(tags = "配件管理管理")
@RestController
@RequestMapping("/api/tower/tower-accessory")
public class TowerAccessoryController extends BaseController {
    @Resource
    private TowerAccessoryService towerAccessoryService;

    @PreAuthorize("hasAuthority('tower:towerAccessory:list')")
    @OperationLog
    @ApiOperation("分页查询配件管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerAccessory>> page(TowerAccessoryParam param) {
        // 使用关联查询
        return success(towerAccessoryService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:list')")
    @OperationLog
    @ApiOperation("查询全部配件管理")
    @GetMapping()
    public ApiResult<List<TowerAccessory>> list(TowerAccessoryParam param) {
        // 使用关联查询
        return success(towerAccessoryService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:list')")
    @OperationLog
    @ApiOperation("根据id查询配件管理")
    @GetMapping("/{id}")
    public ApiResult<TowerAccessory> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(towerAccessoryService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:save')")
    @OperationLog
    @ApiOperation("添加配件管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerAccessory towerAccessory) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerAccessory.setUserId(loginUser.getUserId());
        }
        if (towerAccessoryService.save(towerAccessory)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:update')")
    @OperationLog
    @ApiOperation("修改配件管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerAccessory towerAccessory) {
        if (towerAccessoryService.updateById(towerAccessory)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:remove')")
    @OperationLog
    @ApiOperation("删除配件管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerAccessoryService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:save')")
    @OperationLog
    @ApiOperation("批量添加配件管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerAccessory> list) {
        if (towerAccessoryService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:update')")
    @OperationLog
    @ApiOperation("批量修改配件管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerAccessory> batchParam) {
        if (batchParam.update(towerAccessoryService, "accessory_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerAccessory:remove')")
    @OperationLog
    @ApiOperation("批量删除配件管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerAccessoryService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
